function [err,eltime]=outmatlab(x1,x2,val,targetMode,ntarget,grd1,grd2,hes11,hes12,hes22,xi1,xi2,eltime,err,funct_,xrange,yrange,ptype)
f1 = figure(1);
set(f1, 'Name', 'Function plot');
subplot(2,2,1);

if (targetMode == 2 & ntarget > 1)
    % Draw surface if target points are on a uniform grid.
    xx = reshape(x1, ntarget, ntarget);
	yy = reshape(x2, ntarget, ntarget);
    surf(xx, yy, feval(funct_,xx,yy));
else
    builtin('plot3',x1',x2',feval(funct_,x1,x2)', '.');
end

v=axis;
axis([xrange(1) xrange(2) yrange(1) yrange(2) v(5) v(6)]);
grid on;
title('original');
subplot(2,2,2);

if (targetMode == 2 & ntarget > 1)
    % Draw surface.
	zz = reshape(val, ntarget, ntarget);
	surf(xx, yy, zz);
else
    % Use builtin for compatibility reason with Matlab 7
    builtin('plot3',x1',x2',val', '.');
end

axis([xrange(1) xrange(2) yrange(1) yrange(2) v(5) v(6)]);
grid on;
if (strcmp(ptype, 'Xu') == 1 | strcmp(ptype, 'XuSP') == 1)
    title('hyper on targets');
else
    title('interpolation on targets');
end

subplot(2,2,3);
plot(xi1',xi2', '+');
axis equal;
axis([xrange(1) xrange(2) yrange(1) yrange(2)]);
grid on;
if (strcmp(ptype, 'Xu') == 1 | strcmp(ptype, 'XuSP') == 1)
    title('Xu points');
else
    title('Padua points');
end
subplot(2,2,4);
builtin('plot3',xi1',xi2',feval(funct_,xi1,xi2)', '.');
axis([xrange(1) xrange(2) yrange(1) yrange(2) v(5) v(6)]);
grid on;
if (strcmp(ptype, 'Xu') == 1 | strcmp(ptype, 'XuSP') == 1)
    title('original on Xu');
else
    title('original on Padua');
end
fig=2;

if (grd1~=0) 
	f2 = figure(fig);
	set(f2, 'Name', 'Gradient plot');
	subplot(1,2,1);
	if (targetMode == 2 & ntarget > 1)
        grd1Z = reshape(grd1, ntarget, ntarget);
        surf(xx, yy, grd1Z);
	else
        builtin('plot3',x1',x2',grd1','.');
	end
	grid on
	v=axis;
	axis([xrange(1) xrange(2) yrange(1) yrange(2) v(5) v(6)]);
	title('d/dx');
	subplot(1,2,2);
	if (targetMode == 2 & ntarget > 1)
        grd2Z = reshape(grd2, ntarget, ntarget);
        surf(xx, yy, grd2Z);
	else
        builtin('plot3',x1',x2',grd2','.');
	end
	grid on
	v=axis;
	axis([xrange(1) xrange(2) yrange(1) yrange(2) v(5) v(6)]);
	title('d/dy');
	fig=fig+1;
end
if (hes11~=0)
	f3 = figure(fig);
	set(f3, 'Name', 'Hessian plot');
	subplot(2,2,1);
    if (targetMode == 2 & ntarget > 1)
        hes11Z = reshape(hes11, ntarget, ntarget);
        surf(xx, yy, hes11Z);
    else
	    builtin('plot3',x1',x2',hes11','.');
    end
	grid on
	v=axis;
	axis([xrange(1) xrange(2) yrange(1) yrange(2) v(5) v(6)]);
	title('d2/dx2');
	subplot(2,2,2);
    if (targetMode == 2 & ntarget > 1)
        hes12Z = reshape(hes12, ntarget, ntarget);
        surf(xx, yy, hes12Z);
    else
	    builtin('plot3',x1',x2',hes12','.');
    end
	grid on
	v=axis;
	axis([xrange(1) xrange(2) yrange(1) yrange(2) v(5) v(6)]);
	title('d2/dxdy');
	subplot(2,2,3);
    if (targetMode == 2 & ntarget > 1)
        hes12Z = reshape(hes12, ntarget, ntarget);
        surf(xx, yy, hes12Z);
    else
    	builtin('plot3',x1',x2',hes12','.');
    end
	grid on
	v=axis;
	axis([xrange(1) xrange(2) yrange(1) yrange(2) v(5) v(6)]);
	title('d2/dydx');
	subplot(2,2,4);
    if (targetMode == 2 & ntarget > 1)
        hes22Z = reshape(hes22, ntarget, ntarget);
        surf(xx, yy, hes22Z);
    else
	    builtin('plot3',x1',x2',hes22,'.');
    end
	grid on
	v=axis;
	axis([xrange(1) xrange(2) yrange(1) yrange(2) v(5) v(6)]);
	title('d2/dy2');
end